CKEDITOR.plugins.add( 'bimgiphy', {
	requires: 'widget',
    icons: 'bimgiphy',
    hidpi: true,
    init: function( editor ) {
	    /* Handle upcasting so existing code blocks are drgagable as widgets and not editable */
		editor.widgets.add( 'bimgiphy', {
			template: "<div class='bimGiphy'></div>",    
	    	upcast: function( element ) {
                return element.name == 'div' && element.hasClass( 'bimGiphy' );
            }
	    } );
	    /* The command when the button is pressed */
    	editor.addCommand( 'bimGiphy', {
		    exec: function( editor ) {				
		    	var current = '';
		    	var url = '?app=core&module=system&controller=plugins&do=bimGiphy&editorId=' + editor.name;

				var recent = ips.utils.db.get( 'bimgiphy_gif', 'recent' );
				var recentData = null;
				if ( _.isArray( recent ) ) {
					recentData = JSON.stringify(recent);
				}
			
				var dialogRef = ips.ui.dialog.create({
					fixed: false,
					size: 'medium',
					title: ips.getString( 'bim_giphy' ),
				    url: url,
					forceReload: true,
				    ajax: { 
						type: 'post',
						data: {
							recent: recentData
						},
					}
				});
				dialogRef.show();
		    }
		});
		
		/* Add the button */
		editor.ui.addButton( 'bimGiphy', {
		    label: ips.getString( 'bim_giphy' ),
		    command: 'bimGiphy',
		    toolbar: 'insert'
		});
    }
});